/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdvk1;

import java.awt.Dimension;
import java.awt.GraphicsEnvironment;
import java.awt.Point;
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.net.ssl.HttpsURLConnection;
import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.SwingWorker;
import javax.swing.text.BadLocationException;


/**
 *
 * @author mdvk
 */
public class FormMain extends javax.swing.JFrame {
    private final String USER_AGENT = "Mozilla/5.0";
    private final char NEWLINE = '\n';

    /**
     * Creates new form FormMain
     */
    public FormMain() {
        initComponents();
        setUpKomponen();
        centerFrame();
        setResizable(false);
        setSize(470,371);  // W , H
        setTitle(" MAC CHECKER ");
    }    

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        txLog = new javax.swing.JTextField();
        btnStart = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        lblStatus = new javax.swing.JLabel();
        btnStop = new javax.swing.JButton();
        txRun = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txTarget = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        txResult = new javax.swing.JTextArea();

        txLog.setText("jTextField1");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setBackground(new java.awt.Color(36, 46, 68));
        setForeground(java.awt.Color.lightGray);
        setLocation(new java.awt.Point(250, 250));
        setResizable(false);
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        btnStart.setText("START");
        btnStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnStartActionPerformed(evt);
            }
        });
        getContentPane().add(btnStart, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 270, 109, 45));

        jLabel1.setText("STATUS : ");
        getContentPane().add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 280, -1, -1));

        lblStatus.setText("Iddle");
        getContentPane().add(lblStatus, new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 280, -1, -1));

        btnStop.setText("STOP");
        btnStop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnStopActionPerformed(evt);
            }
        });
        getContentPane().add(btnStop, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 270, 77, 45));

        txRun.setText("__________________");
        getContentPane().add(txRun, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 300, -1, -1));

        jPanel1.setPreferredSize(new java.awt.Dimension(160, 100));

        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane1.setToolTipText("");

        txTarget.setColumns(20);
        txTarget.setRows(5);
        txTarget.setBorder(null);
        jScrollPane1.setViewportView(txTarget);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE)
        );

        getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 150, 250));

        jPanel2.setPreferredSize(new java.awt.Dimension(160, 100));

        jScrollPane2.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane2.setToolTipText("");

        txResult.setColumns(20);
        txResult.setRows(5);
        txResult.setBorder(null);
        jScrollPane2.setViewportView(txResult);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE)
        );

        getContentPane().add(jPanel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 10, 290, 250));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
    private void setUpKomponen(){
        txLog.setVisible(false);
        btnStart.setEnabled(true);
        btnStop.setEnabled(false);
        jPanel1.setBorder(BorderFactory.createTitledBorder("MAC TARGET"));
        jPanel2.setBorder(BorderFactory.createTitledBorder("RESULT"));

        

    }
    
      private void centerFrame() {

            Dimension windowSize = getSize();
            GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
            Point centerPoint = ge.getCenterPoint();

            int dx = centerPoint.x - windowSize.width / 2;
            int dy = centerPoint.y - windowSize.height / 2;    
            setLocation(dx, dy);
    }
    
   
    
    private void btnStartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnStartActionPerformed
        (t = new aTask()).execute();
        btnStart.setEnabled(false);
        btnStop.setEnabled(true);

        
    }//GEN-LAST:event_btnStartActionPerformed

    private void btnStopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnStopActionPerformed
        if(t !=null){
            t.cancel(true);
            t = null;
            btnStart.setEnabled(true);
            btnStop.setEnabled(false);
        }
        
    }//GEN-LAST:event_btnStopActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Windows".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FormMain.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FormMain().setVisible(true);                
            }
        });
    }
    
    
    
    
    
    //--------------------------------------------------------
    // REGION FUNCTION
    //--------------------------------------------------------

	public void HttpGet(String target) throws Exception {// HTTP GET request

		String url = "http://118.97.116.26/wifi.id/default/?gw_id=WAG-D3-LBG&client_mac=" + target;
		URL obj = new URL(url);
		HttpURLConnection con = (HttpURLConnection) obj.openConnection();

		// optional default is GET
		con.setRequestMethod("GET");

		//add request header
		con.setRequestProperty("User-Agent", USER_AGENT);

		int responseCode = con.getResponseCode();
		System.out.println("\nSending 'GET' request to URL : " + url);
		System.out.println("Response Code : " + responseCode);
		
		txLog.setText("\nSending Get request to URL : "+url);
		

		BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
		String inputLine;
		StringBuilder response = new StringBuilder();

		while ((inputLine = in.readLine()) != null) {
			response.append(inputLine);
		}
		in.close();

		//print result
		System.out.println(response.toString());
		txLog.setText(response.toString());
                
                
		
	}
        
        private class aTask extends SwingWorker<Void, String> {

        @Override
        protected void done() {
         if(t !=null){
                t.cancel(true);
                t = null;
                btnStart.setEnabled(true);
                btnStop.setEnabled(false);
            }
            JOptionPane.showMessageDialog(null, "Task Done .", "Information", JOptionPane.INFORMATION_MESSAGE);
        }


        @Override
        protected Void doInBackground() throws Exception {
            String[] lines = txTarget.getText().split("\\n");
            int totLine = txTarget.getLineCount();
            for (int i=0; i < totLine; i++){
                int counter =i + 1;
                lblStatus.setText(counter +" of " + totLine);
                txRun.setText("SCAN : "+lines[i]);
                HttpGet(lines[i]);
                
                // Checker
                try{
                    if(txLog.getText().contains("@telkom")){
                        txLog.setText("");
                        txResult.setText(txResult.getText() +lines[i] + '\n');
                    }
                }catch(Exception e){
                    // TODO Add
                }
            }
            return null;
        }
            
        }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnStart;
    private javax.swing.JButton btnStop;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel lblStatus;
    private javax.swing.JTextField txLog;
    private javax.swing.JTextArea txResult;
    private javax.swing.JLabel txRun;
    private javax.swing.JTextArea txTarget;
    // End of variables declaration//GEN-END:variables
    private aTask t;
}
